//
//  UIImage-Additions.m
//
//  Created by boreal-kiss.com on 10/08/13.
//  Copyright 2010 boreal-kiss.com. All rights reserved.
//

#import "UIImage-Additions.h"

@implementation UIImage (Additions)

+(UIImage *)subimageWithImage:(UIImage *)image inRect:(CGRect)rect{
	CGImageRef imageRef = CGImageCreateWithImageInRect(image.CGImage, rect);
	UIImage *subimage = [UIImage imageWithCGImage:imageRef];
	CGImageRelease(imageRef);
	return subimage;
}

+(UIImage *)scaledImageWithImage:(UIImage*)image inSize:(CGSize)size{
	UIGraphicsBeginImageContext(size);
	[image drawInRect:CGRectMake(0, 0, size.width, size.height)];
	UIImage* newImage = UIGraphicsGetImageFromCurrentImageContext();
	UIGraphicsEndImageContext();
	return newImage;
}

+(UIImage *)rotatedImageWithImage:(UIImage *)image{
	CGSize s = image.size;
	CGFloat w = s.width;
	CGFloat h = s.height;
	CGRect rect = CGRectMake(0, 0, w, h);
	
	UIGraphicsBeginImageContext(s);
    CGContextRef c = UIGraphicsGetCurrentContext();
	
	switch (image.imageOrientation) {
		case UIImageOrientationUp:
			//NSLog(@"UIImageOrientationUp");
			
			CGContextScaleCTM(c, 1, -1);
			CGContextTranslateCTM(c, 0, -h);
			rect = CGRectMake(0, 0, w, h);
			break;
		case UIImageOrientationDown:
			//NSLog(@"UIImageOrientationDown");
			
			CGContextScaleCTM(c, -1, 1);
			CGContextTranslateCTM(c, -w, 0);
			rect = CGRectMake(0, 0, w, h);
			break;
		case UIImageOrientationLeft:
			//NSLog(@"UIImageOrientationLeft");
			
			CGContextRotateCTM(c, -M_PI/2);
			CGContextScaleCTM(c, 1, -1);
			//CGContextTranslateCTM(c, -w, -h);//Why incorrect???
			CGContextTranslateCTM(c, -h, -w);
			rect = CGRectMake(0, 0, h, w);
			break;
		case UIImageOrientationRight:
			//NSLog(@"UIImageOrientationRight");
			
			CGContextRotateCTM(c, M_PI/2);
			CGContextScaleCTM(c, 1, -1);
			rect = CGRectMake(0, 0, h, w);
			break;	
	}
	
	CGContextDrawImage(c, rect, image.CGImage);
    UIImage *rotatedImage = UIGraphicsGetImageFromCurrentImageContext();
    UIGraphicsEndImageContext();
	
	return rotatedImage;
}


@end
