//
//  UIImage-Image2x.m
//  Image2x
//
//  Created by boreal-kiss.com on 10/08/14.
//  Copyright 2010 boreal-kiss.com. All rights reserved.
//

#import "UIImage-Image2x.h"

@implementation UIImage (Image2x)

+(UIImage *)image2xWithData:(NSData *)data{
	return [[self class] imageWithData:data scale:2.0 orientation:UIImageOrientationUp];
}

+(UIImage *)imageWithData:(NSData *)data scale:(CGFloat)scale orientation:(UIImageOrientation)orientation{
	CGDataProviderRef provider = CGDataProviderCreateWithCFData((CFDataRef)data);
	CGImageRef imageRef = CGImageCreateWithPNGDataProvider(provider, NULL, true, kCGRenderingIntentDefault);
	
	if (imageRef == nil){
		imageRef = CGImageCreateWithJPEGDataProvider(provider, NULL, true, kCGRenderingIntentDefault);
	}
	
	//Cleanups.
	[(id)provider release];
	[(id)imageRef autorelease];
	
	return [UIImage imageWithCGImage:imageRef scale:scale orientation:orientation];
}

@end
